// ue01b.c: Typen, Strings
// Systemprogrammierung SS 2014, H.-G. Esser

#include <stdio.h>    // printf, snprintf
#include <string.h>   // strncpy
#include <stdlib.h>   // malloc

#define STRLEN 25

int i;
long int j;
float f;
char c;
// boolean b;         // gibt es nicht, kein boolescher Typ in C

char str1[STRLEN];
char str2[STRLEN];

char *str3;

typedef struct {
  char s[STRLEN];
} mystring;

mystring ms1, ms2;

int main () {
  i = 10;
  snprintf (str1, STRLEN, "Wert von i ist %d............", i);
  str1[STRLEN-1] = '\0';
  
  // str2 = str1;   // direkte Zuweisung geht nicht
  strncpy (str2, str1, STRLEN);
  
  str3 = malloc(STRLEN);
  strncpy (str3, str1, STRLEN);

  strncpy (ms1.s, str1, STRLEN);
  ms2 = ms1;        // Struktur mit String drin kann ich kopieren,
                    // obwohl es mit einfachen Strings fester
                    // Laenge nicht geht...
  
  printf ("STRLEN = %d\n", STRLEN);
  printf ("       0....5...10...15...20...25...30\n");
  printf ("       |    |    |    |    |    |    |\n");

  printf ("str1:  %s\n", str1);    printf ("str2:  %s\n", str2);
  printf ("str3:  %s\n", str3);    
  printf ("ms1.s: %s\n", ms1.s);   printf ("ms2.s: %s\n", ms2.s);
  
  return 0;
}

