// ue01c.c: Funktionen und Pointer
// Systemprogrammierung SS 2014, H.-G. Esser

#include <stdio.h>   // printf
#include <string.h>  // strlen
#include <stdlib.h>  // malloc

// void ist ein leerer Typ
void copy_string (char *copy, char *orig) {
  while ( *orig != 0 ) {
    *copy = *orig;
    copy++;
    orig++;
  }
  *copy = 0;  // String terminieren
  return;
}


void sub_string (char *target, char *orig, int anfang, int ende) {
  int pos = 0;
  while ( *orig != 0 ) {
    if (pos >= anfang && pos <= ende) {
      *target = *orig;
      target++;
    }
    orig++;
    pos++;
  }
  *target = '\0';  // Sub-String terminieren
  return;
}


// Hauptprogramm
int main () {
  char s1[] = "Das ist ein kleiner Test";
  char *s2;
  char *s3;
  char *s4;
  
  int len;    // Groesse des Strings
  
  s2 = s1;    // Das geht, aber kopiert nicht den String!
  
  len = strlen (s1);
  s3 = malloc (len+1);
  s4 = malloc (len+1);
  copy_string (s3, s1);
  sub_string (s4, s1, 3, 6);

  // Erste drei Zeichen ("Das") in s1 ueberschreiben:
  s1[0] = 'A';
  s1[1] = 'B';
  s1[2] = 'C';
  
  printf ("s1 = \"%s\" \n", s1);
  printf ("s2 = \"%s\" \n", s2);
  printf ("s3 = \"%s\" \n", s3);
  printf ("s4 = \"%s\" \n", s4);
  return 0;
}

